export var BOOT_MAGIC = "ANDROID!";
export var BOOT_MAGIC_SIZE = 8;
export var BOOT_NAME_SIZE = 16;
export var BOOT_ARGS_SIZE = 512;

export struct BootImageHeader {
  u8[BOOT_MAGIC_SIZE] magic;
  u32 kernel_size;    // size in bytes
  u32 kernel_addr;    // physical load address
  u32 ramdisk_size;   // size in bytes
  u32 ramdisk_addr;   // physical load address
  u32 second_size;    // size in bytes
  u32 second_addr;    // physical load address
  u32 tags_addr;      // physical address for kernel tags
  u32 page_size;      // flash page size assumed
  u32[2] unused;      // future expansion, should be zero
  u8[BOOT_NAME_SIZE] name; // null-terminated product name
  u8[BOOT_ARGS_SIZE] cmdline;
  u32[8] id;           // timestamp / checksum / sha1 / etc
}

// https://android.googlesource.com/platform/system/tools/mkbootimg/+/refs/heads/main/include/bootimg/bootimg.h